import os
pathJoin = os.path.join
pathUp = os.path.dirname
pathScript = pathUp(os.path.realpath(__file__))
pathDoc = pathScript
pathTweaks = pathJoin(pathUp(pathScript),"tweaks")
pathTweaksReversal = pathJoin(pathUp(pathScript),"tweaks - reversal")

def walklevel(some_dir, level=0):
	if level < 0:
		for root, dirs, files in os.walk(some_dir):
			yield root,dirs,files
		
		return
	
	some_dir = some_dir.rstrip(os.path.sep)
	assert os.path.isdir(some_dir)
	num_sep = some_dir.count(os.path.sep)
	for root, dirs, files in os.walk(some_dir):
		yield root, dirs, files
		num_sep_this = root.count(os.path.sep)
		if num_sep + level <= num_sep_this:
			del dirs[:]

def yieldTweaks(tdir):
	for root,dirs,files in walklevel(tdir):
		for dir in dirs:
			fdir = pathJoin(root,dir)
			if dir[0] == "-": continue
			if dir[0] == "[" and dir[-1] == "]":
				for ftweak in yieldTweaks(fdir):
					yield ftweak
				continue
			
			yield fdir

mdTweaksOut = pathJoin(pathDoc,"tweaksGenerated.md")
mdTweaksFile = open(mdTweaksOut,"w")

mdTweaksFile.write("""you can find all tweaks in the \\tweaks\\ directory of opus-nt.
 
## legend

uwu - added registry value. accurately reversible.  
owo - changed registry value. may not accurately revert.  
ÒwÓ - complex modification/file modification. no reversal-tweak available.  

i do not guarantee that that all of the reversals are accurate across different releases, the green ones are just fairly likely to be accurate. **please do** nag me if the defaults have changed, though. i would love to nail these as good as i can.

<br>

|  | **name** | **details** |
| :---: | --- | --- |
""")

for tweak in yieldTweaks(pathTweaks):
	tweakLocal = tweak.replace(pathTweaks + os.sep,"",1)
	tweakLocalFriendly = tweakLocal.replace(os.sep,"/")
	
	tweakNameFriendly = tweakLocalFriendly
	tweakNameFriendly = tweakNameFriendly.replace("[","\\[")
	tweakNameFriendly = tweakNameFriendly.replace("]","\\]")
	
	tweakLocalFriendly = "tweaks/" + tweakLocalFriendly
	
	info = "no details available"
	pathInfo = pathJoin(tweak,"details.md")
	if os.path.isfile(pathInfo):
		info = open(pathInfo,"r").read()
	mdTweaksFile.write("| x | [" +tweakNameFriendly+ "](../" +tweakLocalFriendly+ ") | " +info+ " |   \n")

mdTweaksFile.close()