from munch import *
import os
import time
import subprocess
import winreg
import ntpath

opus = Munch()

if True: #opus.path
	opus.path = Munch()
	def _opusPathWalklevel(some_dir, level=0):
		if level < 0:
			for root, dirs, files in os.walk(some_dir):
				yield root,dirs,files
			
			return
		
		some_dir = some_dir.rstrip(os.path.sep)
		assert os.path.isdir(some_dir)
		num_sep = some_dir.count(os.path.sep)
		for root, dirs, files in os.walk(some_dir):
			yield root, dirs, files
			num_sep_this = root.count(os.path.sep)
			if num_sep + level <= num_sep_this:
				del dirs[:]
	opus.path.walklevel = _opusPathWalklevel

if True: #opus.reg
	opus.reg = Munch()
	opus.reg.path = Munch()
	opus.reg.path.sep = "\\"
	opus.reg.path.hkeys = {}
	opus.reg.path.hkeys["HKEY_CLASSES_ROOT"] = winreg.HKEY_CLASSES_ROOT
	opus.reg.path.hkeys["HKCR"] = opus.reg.path.hkeys["HKEY_CLASSES_ROOT"]
	opus.reg.path.hkeys["HKEY_CURRENT_USER"] = winreg.HKEY_CURRENT_USER
	opus.reg.path.hkeys["HKCU"] = opus.reg.path.hkeys["HKEY_CURRENT_USER"]
	opus.reg.path.hkeys["HKEY_LOCAL_MACHINE"] = winreg.HKEY_LOCAL_MACHINE
	opus.reg.path.hkeys["HKLM"] = opus.reg.path.hkeys["HKEY_LOCAL_MACHINE"]
	opus.reg.path.hkeys["HKEY_USERS"] = winreg.HKEY_USERS
	opus.reg.path.hkeys["HKU"] = opus.reg.path.hkeys["HKEY_USERS"]
	opus.reg.path.hkeys["HKEY_CURRENT_CONFIG"] = winreg.HKEY_CURRENT_CONFIG
	opus.reg.path.hkeys["HKCU"] = opus.reg.path.hkeys["HKEY_CURRENT_CONFIG"]

	def _opusRegGetData(key,value):
		hkey, key = opus.reg.path.toWinreg(key)
		with winreg.OpenKey(hkey,key) as keyObject:
			return winreg.QueryValueEx(keyObject,value)
	opus.reg.getData = _opusRegGetData
	
	def _opusRegIterateKey(key):
		hkey, key = opus.reg.path.toWinreg(key)
		with winreg.OpenKey(winreg.HKEY_LOCAL_MACHINE,key) as keyObject:
			index = 0
			length = winreg.QueryInfoKey(keyObject)[1]
			while index < length:
				valueInfo = winreg.EnumValue(keyObject,index)
				yield valueInfo[0], valueInfo[1], valueInfo[2]
				index = index + 1
	opus.reg.iterateKey = _opusRegIterateKey
	
	def _opusRegAdd(key, value = False, valueType = False, data = False):
		cmdList = ["reg","add",key]
		
		if value == "":
			cmdList = cmdList + ["/ve","/d",data]
		elif value != False:
			cmdList = cmdList + ["/v",value,"/t",valueType,"/d",data]
		
		cmdList.append("/f")
		rtn = subprocess.call(cmdList)
		if rtn > 0: raise Exception("reg")
	opus.reg.add = _opusRegAdd

	def _opusRegDelete(key, value = False):
		cmdList = ["reg","delete",key]
		if value != False:
			cmdList = cmdList + ["/v",value]
		
		cmdList.append("/f")
		rtn = subprocess.call(cmdList)
		if rtn > 0: raise Exception("reg")
	opus.reg.delete = _opusRegDelete

	def _opusRegLoad(key, file):
		cmdList = ["reg","load",key,file]
		rtn = subprocess.call(cmdList)
		if rtn > 0: raise Exception("reg")
	opus.reg.load = _opusRegLoad

	def _opusRegUnload(key):
		cmdList = ["reg","unload",key]
		rtn = subprocess.call(cmdList)
		if rtn > 0: raise Exception("reg")
	opus.reg.unload = _opusRegUnload
	
	def _opusRegPathJoin(ls):
		return opus.reg.path.sep.join(ls)
	opus.reg.path.join = _opusRegPathJoin
	
	def _opusRegPathToWinreg(key):
		hkey = False
		for hk in opus.reg.path.hkeys:
			if key.startswith(hk + opus.reg.path.sep):
				key = key.replace(hk + opus.reg.path.sep,"",1)
				hkey = opus.reg.path.hkeys[hk]
				break
		
		if hkey == False: raise Exception("not a valid registry path")
		return hkey, key
	opus.reg.path.toWinreg = _opusRegPathToWinreg

if True: #opus.os
	opus.os = Munch()
	def _opusOsGetInfo(SOFTWARE):
		osInfo = Munch()
		osInfo.version = Munch()
		osInfo.key = Munch()
		osInfo.tags = []
		
		for value,data,valueType in opus.reg.iterateKey(opus.reg.path.join([SOFTWARE,"Microsoft","Windows NT","CurrentVersion"])):
			osInfo.key[value] = data
		
		osInfo.version.major = False
		osInfo.version.minor = False
		osInfo.version.string = False
		if "CurrentMajorVersionNumber" in osInfo.key:
			osInfo.version.major = int(osInfo.key.CurrentMajorVersionNumber)
			osInfo.version.minor = int(osInfo.key.CurrentMinorVersionNumber)
			osInfo.version.string = str(osInfo.version.major)+ "." +str(osInfo.version.minor)
		else:
			osInfo.version.string = osInfo.key.CurrentVersion
			osInfo.version.major = int(osInfo.version.string.split(".")[0])
			osInfo.version.minor = int(osInfo.version.string.split(".")[1])
		
		if osInfo.version.major == False: raise Exception("unknown windows nt version")
		
		if osInfo.version.major > 5 and osInfo.version.major < 11: osInfo.tags.append("longhorn-series")
		if osInfo.version.string == "6.0": osInfo.tags.append("vista")
		if osInfo.version.string == "6.1": osInfo.tags.append("seven")
		if osInfo.version.string == "6.2": osInfo.tags.append("eight")
		if osInfo.version.string == "6.3": osInfo.tags.append("eightone"); osInfo.tags.append("nine")
		if osInfo.version.string == "10.0": osInfo.tags.append("ten")
		
		return osInfo
	opus.os.getInfo = _opusOsGetInfo

if True: #opus.wim
	opus.wim = Munch()
	
	def _opusWimExtract(wim,index,wimFile,outPath):
		rtn = subprocess.call([
			"wimlib-imagex","extract",
			wim,str(index),
			wimFile,
			"--dest-dir=" +outPath,"--preserve-dir-structure"
		])
		if rtn > 0: raise Exception("wim")
	opus.wim.extract = _opusWimExtract
	
	def _opusWimUpdate(wim,index,inPath):
		rtn = subprocess.call([
			"wimlib-imagex","update",
			wim,str(index),
			"--command=add '" +inPath+ "' '\\'"
		])
		if rtn > 0: raise Exception("wim")
	opus.wim.update = _opusWimUpdate
	
	def _opusWimGetImageAmount(wim):
		index = 0
		while True:
			index = index + 1
			rtn = subprocess.call([
				"wimlib-imagex","info",
				wim,str(index)
			])
			if rtn > 0: return index - 1
	opus.wim.getImageAmount = _opusWimGetImageAmount

env = Munch()
def main():
	global env
	env.timeBuild = int(time.time())
	env.pathJoin = os.path.join
	env.pathUp = os.path.dirname
	env.pathScript = env.pathUp(os.path.realpath(__file__))
	
	env.tmp = env.pathJoin(env.pathScript,"tmp",str(env.timeBuild))
	env.tmpWim = env.pathJoin(env.tmp,"wim")
	env.tweaks = env.pathJoin(env.pathScript,"tweaks")
	env.reg = Munch()
	env.wim = False
	env.index = 1
	env.images = 1
	
	def applyTweaks(tdir):
		global env
		for root,dirs,files in opus.path.walklevel(tdir):
			for dir in dirs:
				fdir = env.pathJoin(root,dir)
				if dir[0] == "-": continue
				if dir[0] == "[" and dir[-1] == "]":
					for fscript in applyTweaks(fdir):
						yield fscript
					continue
				
				fscript = env.pathJoin(fdir,"apply.py")
				if not os.path.isfile(fscript): continue
				
				with open(fscript) as f:
					env.fdir = fdir
					code = compile(f.read(), fscript, 'exec')
					
					env.applied = True
					exec(code,globals(),locals())
					if env.applied == True: yield fdir
	
	print(">>> EXPANDING PATH: ",end="")
	for root,dirs,files in opus.path.walklevel(env.pathJoin(env.pathScript,"path")):
		for dir in dirs:
			print(dir,end=";")
			os.environ["Path"] = os.environ["Path"] + ";" + env.pathJoin(root,dir)
	print(" <<<\n")
	
	print("action:")
	print("1) apply to current system")
	print("2) apply to wim")
	env.applicationMode = int(input("choice: "))
	
	if env.applicationMode == 1:
		env.reg.software = opus.reg.path.join(["HKLM","SOFTWARE"])
		env.reg.system = opus.reg.path.join(["HKLM","SYSTEM"])
		env.reg.users = ["HKCU",opus.reg.path.join(["HKU",".DEFAULT"])]
		
		choice = input("this will apply all tweaks in \\tweaks to your currently running system. are you certain that you want this? [y/n]")
		if (choice.lower() != "y"): return
	
	if env.applicationMode == 2:
		env.reg.software = opus.reg.path.join(["HKLM","OPUS-TMP_" +str(env.timeBuild)+ "_SOFTWARE"])
		env.reg.system = opus.reg.path.join(["HKLM","OPUS-TMP_" +str(env.timeBuild)+ "_SYSTEM"])
		env.reg.users = [opus.reg.path.join(["HKLM","OPUS-TMP_" +str(env.timeBuild)+ "_NTUSER"])]
		
		env.wim = input("wim-file (install.wim): ")
		simage = input("image index (* for all):")
		if (simage == "*"):
			env.images = opus.wim.getImageAmount(env.wim)
		else:
			env.index = int(simage)
			env.images = int(simage)
	
	while (env.index <= env.images):
		os.makedirs(env.tmpWim)
		if env.applicationMode == 2:
			print("\n>>> PROCESSING IMAGE " +str(env.index)+ " <<<")
			env.pSoftware = env.pathJoin("Windows","System32","config","SOFTWARE")
			env.pSystem = env.pathJoin("Windows","System32","config","SYSTEM")
			env.pUser = env.pathJoin("Users","Default","NTUSER.DAT")
			opus.wim.extract(env.wim,env.index,env.pSoftware,env.tmpWim)
			opus.wim.extract(env.wim,env.index,env.pSystem,env.tmpWim)
			opus.wim.extract(env.wim,env.index,env.pUser,env.tmpWim)
			opus.reg.load(env.reg.software,env.pathJoin(env.tmpWim,env.pSoftware))
			opus.reg.load(env.reg.system,env.pathJoin(env.tmpWim,env.pSystem))
			opus.reg.load(env.reg.users[0],env.pathJoin(env.tmpWim,env.pUser))
		
		env.os = opus.os.getInfo(env.reg.software)
		print("")
		for tweak in applyTweaks(env.tweaks):
			print(">> APPLIED TWEAK: " +tweak.replace(env.tweaks + os.path.sep,"",1))
		print("")
		
		if env.applicationMode == 2:
			print(">> UPDATING WIM...")
			opus.reg.unload(env.reg.software)
			opus.reg.unload(env.reg.system)
			opus.reg.unload(env.reg.users[0])
			opus.wim.update(env.wim,env.index,env.tmpWim)
			subprocess.call(["rmdir","/s","/q",env.tmpWim],shell=True)
		env.index = env.index + 1
	
if __name__ == "__main__":
	#print(opus.os.getInfo("HKLM").tags)
	main()
	